package invertedpendulum;

import java.awt.Color;
import java.awt.Graphics;

public class Graph {

	private Color myColor;
	
	private float values[];
	private int xvals[];
	private int yvals[];
	
	private int offsetX, offsetY;
	
	private float xScale, yScale;
	private float yStart,yEnd;
	private int numValues;
	
	public Graph(int size){
		values=new float[size];
		xvals=new int[size];
		yvals=new int[size];
	}
	
	public void setColor(Color c){
		myColor=c;
	}
	
	public void setOffset(int offset_x, int offset_y){
		offsetX=offset_x;
		offsetY=offset_y;
		
		for (int i=0;i<xvals.length;i++){
			xvals[i]=(int)(i*xScale) + offsetX;
		}
	}
	
	private void convertToInt(){
		for (int i=0;i<yvals.length;i++){
//			if (yvals[i]<yStart)
//				yvals[i]=offsetY - (int)(yStart*yScale);
//			else if (yvals[i]>yEnd)
//				yvals[i]=offsetY - (int)(yEnd*yScale);
//			else
				yvals[i]=-(int)((float)values[i]*(float)yScale) + offsetY;
		}
	//	System.out.println("Value: "+values[yvals.length-1] + " : " + yvals[yvals.length-1] + ", scale = " + yScale + ", " + offsetY);
	}
	
	public void setScale(float scale_x, float scale_y){
		xScale=scale_x;
		yScale=scale_y;
	}
	
	public void setYBounds(float start_y, float end_y){
		yStart=start_y;
		yEnd=end_y;
	}
	
	public void shiftLeft(){
		for (int i=1;i<numValues;i++){
			values[i-1]=values[i];
		}
	}
	
	public void insertValue(float value){	
		if (numValues==values.length){
			shiftLeft();
			values[numValues-1]=value;
		}
		else{
			numValues++;
			values[numValues]=value;
		}	
	}
	
	public void draw(Graphics g){
		//Color oldColor=g.getColor();
		convertToInt();
		g.setColor(myColor);
		g.drawPolyline(xvals, yvals, numValues);
		//g.setColor(oldColor);
	}
}
